---
kind: change
title: Spree 1.2.1 and 1.3.0 API changes
created_at: 2012-10-24
author_name: radar
---

The API in Spree has had some minor changes in the 1.2.x release, as well as in the 1.3.0 release. They are listed below. Please ensure your API clients are updated accordingly.

## Standardize variant response

Previously, variant data was returned like this:

<%= json [ :variant => { :product_id => 1 }] %>

But products were returned like this:

<%= json :products => [ :product => { :id => 1 }] %>

To standardize these responses, variants will now be returned underneath a `variants` key in the JSON response, like this:

<%= json :variants => [ :variant => { :product_id => 1 }] %>

## Standarize payments response

Previously, payments data was returned like this:

<%= json [ :payment => { :payment_method_id => 1 } ] %>

Similar to the previous point, this API will now return payments like this:

<%= json :payments => [ :payment => { :payment_method_id => 1 } ] %>

## Deleted variants

Deleted variants are no longer returned within requests to the variants API endpoint. Admins can view deleted variants by passing along a `show_deleted` parameter which evaluates to a "truthy" value.

## Minor changes

* A request to `POST /api/orders` no longer needs to include parameters for a line item.
* Requests to `POST /api/orders` now return status 201, not 200.
* All DELETE responses will now return status 204, not 200.
